/* ***********************************************************
 * This file was automatically generated on 2014-12-22.      *
 *                                                           *
 * Bindings Version 2.1.5                                    *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for controlling up to 4 optically coupled digital inputs
	/// </summary>
	public class BrickletIndustrialDigitalIn4 : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>
		/// </summary>
		public static int DEVICE_IDENTIFIER = 223;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_VALUE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_GROUP = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_GROUP = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_AVAILABLE_FOR_GROUP = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_INTERRUPT = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_INTERRUPT = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte CALLBACK_INTERRUPT = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_EDGE_COUNT = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_EDGE_COUNT_CONFIG = 11;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_EDGE_COUNT_CONFIG = 12;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		/// </summary>
		public const byte EDGE_TYPE_RISING = 0;

		/// <summary>
		/// </summary>
		public const byte EDGE_TYPE_FALLING = 1;

		/// <summary>
		/// </summary>
		public const byte EDGE_TYPE_BOTH = 2;


		/// <summary>
		///  This callback is triggered whenever a change of the voltage level is detected
		///  on pins where the interrupt was activated with <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.SetInterrupt"/>.
		///  
		///  The values are a bitmask that specifies which interrupts occurred
		///  and the current value bitmask.
		///  
		///  For example:
		///  
		///  * (1, 1) or (0b0001, 0b0001) means that an interrupt on pin 0 occurred and
		///    currently pin 0 is high and pins 1-3 are low.
		///  * (9, 14) or (0b1001, 0b1110) means that interrupts on pins 0 and 3
		///    occurred and currently pin 0 is low and pins 1-3 are high.
		/// </summary>
		public event InterruptEventHandler Interrupt;
		/// <summary>
		/// </summary>
		public delegate void InterruptEventHandler(BrickletIndustrialDigitalIn4 sender, int interruptMask, int valueMask);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletIndustrialDigitalIn4(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			this.apiVersion[0] = 2;
			this.apiVersion[1] = 0;
			this.apiVersion[2] = 1;
			callbackWrappers[CALLBACK_INTERRUPT] = new CallbackWrapper(OnInterrupt);

			responseExpected[FUNCTION_GET_VALUE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_GROUP] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_GROUP] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_AVAILABLE_FOR_GROUP] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_INTERRUPT] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_INTERRUPT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_EDGE_COUNT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_EDGE_COUNT_CONFIG] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_EDGE_COUNT_CONFIG] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_INTERRUPT] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  Returns the input value with a bitmask. The bitmask is 16bit long, *true*
		///  refers to high and *false* refers to low.
		///  
		///  For example: The value 3 or 0b0011 means that pins 0-1 are high and the other
		///  pins are low.
		///  
		///  If no groups are used (see <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.SetGroup"/>), the pins correspond to the
		///  markings on the Digital In 4 Bricklet.
		///  
		///  If groups are used, the pins correspond to the element in the group.
		///  Element 1 in the group will get pins 0-3, element 2 pins 4-7, element 3
		///  pins 8-11 and element 4 pins 12-15.
		/// </summary>
		public int GetValue()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_VALUE);

			byte[] response = SendRequest(request);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets a group of Digital In 4 Bricklets that should work together. You can
		///  find Bricklets that can be grouped together with <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.GetAvailableForGroup"/>.
		///  
		///  The group consists of 4 elements. Element 1 in the group will get pins 0-3,
		///  element 2 pins 4-7, element 3 pins 8-11 and element 4 pins 12-15.
		///  
		///  Each element can either be one of the ports ('a' to 'd') or 'n' if it should
		///  not be used.
		///  
		///  For example: If you have two Digital In 4 Bricklets connected to port A and
		///  port B respectively, you could call with ``['a', 'b', 'n', 'n']``.
		///  
		///  Now the pins on the Digital In 4 on port A are assigned to 0-3 and the
		///  pins on the Digital In 4 on port B are assigned to 4-7. It is now possible
		///  to call <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.GetValue"/> and read out two Bricklets at the same time.
		///  
		///  Changing the group configuration resets all edge counter configurations
		///  and values.
		/// </summary>
		public void SetGroup(char[] group)
		{
			byte[] request = CreateRequestPacket(12, FUNCTION_SET_GROUP);
			LEConverter.To((char[])group, 8, 4, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the group as set by <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.SetGroup"/>
		/// </summary>
		public char[] GetGroup()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_GROUP);

			byte[] response = SendRequest(request);

			return LEConverter.CharArrayFrom(8, response, 4);
		}

		/// <summary>
		///  Returns a bitmask of ports that are available for grouping. For example the
		///  value 5 or 0b0101 means: Port A and port C are connected to Bricklets that
		///  can be grouped together.
		/// </summary>
		public byte GetAvailableForGroup()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_AVAILABLE_FOR_GROUP);

			byte[] response = SendRequest(request);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Sets the debounce period of the <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.Interrupt"/> callback in ms.
		///  
		///  For example: If you set this value to 100, you will get the interrupt
		///  maximal every 100ms. This is necessary if something that bounces is
		///  connected to the Digital In 4 Bricklet, such as a button.
		///  
		///  The default value is 100.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the pins on which an interrupt is activated with a bitmask.
		///  Interrupts are triggered on changes of the voltage level of the pin,
		///  i.e. changes from high to low and low to high.
		///  
		///  For example: An interrupt bitmask of 9 or 0b1001 will enable the interrupt for
		///  pins 0 and 3.
		///  
		///  The interrupts use the grouping as set by <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.SetGroup"/>.
		///  
		///  The interrupt is delivered with the callback <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.Interrupt"/>.
		/// </summary>
		public void SetInterrupt(int interruptMask)
		{
			byte[] request = CreateRequestPacket(10, FUNCTION_SET_INTERRUPT);
			LEConverter.To((short)interruptMask, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the interrupt bitmask as set by <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.SetInterrupt"/>.
		/// </summary>
		public int GetInterrupt()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_INTERRUPT);

			byte[] response = SendRequest(request);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Returns the current value of the edge counter for the selected pin. You can
		///  configure the edges that are counted with <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.SetEdgeCountConfig"/>.
		///  
		///  If you set the reset counter to *true*, the count is set back to 0
		///  directly after it is read.
		///  
		///  .. versionadded:: 2.0.1~(Plugin)
		/// </summary>
		public long GetEdgeCount(byte pin, bool resetCounter)
		{
			byte[] request = CreateRequestPacket(10, FUNCTION_GET_EDGE_COUNT);
			LEConverter.To((byte)pin, 8, request);
			LEConverter.To((bool)resetCounter, 9, request);

			byte[] response = SendRequest(request);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Configures the edge counter for the selected pins. A bitmask of 9 or 0b1001 will
		///  enable the edge counter for pins 0 and 3.
		///  
		///  The edge type parameter configures if rising edges, falling edges or
		///  both are counted if the pin is configured for input. Possible edge types are:
		///  
		///  * 0 = rising (default)
		///  * 1 = falling
		///  * 2 = both
		///  
		///  The debounce time is given in ms.
		///  
		///  Configuring an edge counter resets its value to 0.
		///  
		///  If you don't know what any of this means, just leave it at default. The
		///  default configuration is very likely OK for you.
		///  
		///  Default values: 0 (edge type) and 100ms (debounce time)
		///  
		///  .. versionadded:: 2.0.1~(Plugin)
		/// </summary>
		public void SetEdgeCountConfig(int selectionMask, byte edgeType, byte debounce)
		{
			byte[] request = CreateRequestPacket(12, FUNCTION_SET_EDGE_COUNT_CONFIG);
			LEConverter.To((short)selectionMask, 8, request);
			LEConverter.To((byte)edgeType, 10, request);
			LEConverter.To((byte)debounce, 11, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the edge type and debounce time for the selected pin as set by
		///  <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.SetEdgeCountConfig"/>.
		///  
		///  .. versionadded:: 2.0.1~(Plugin)
		/// </summary>
		public void GetEdgeCountConfig(byte pin, out byte edgeType, out byte debounce)
		{
			byte[] request = CreateRequestPacket(9, FUNCTION_GET_EDGE_COUNT_CONFIG);
			LEConverter.To((byte)pin, 8, request);

			byte[] response = SendRequest(request);

			edgeType = LEConverter.ByteFrom(8, response);
			debounce = LEConverter.ByteFrom(9, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnInterrupt(byte[] response)
		{
			int interruptMask = LEConverter.UShortFrom(8, response);
			int valueMask = LEConverter.UShortFrom(10, response);

			var handler = Interrupt;
			if(handler != null)
			{
				handler(this, interruptMask, valueMask);
			}
		}
	}
}