/* ***********************************************************
 * This file was automatically generated on 2014-12-22.      *
 *                                                           *
 * Bindings Version 2.1.5                                    *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device that controls mains switches remotely
	/// </summary>
	public class BrickletRemoteSwitch : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>
		/// </summary>
		public static int DEVICE_IDENTIFIER = 235;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SWITCH_SOCKET = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_SWITCHING_STATE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte CALLBACK_SWITCHING_DONE = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_REPEATS = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_REPEATS = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SWITCH_SOCKET_A = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SWITCH_SOCKET_B = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_DIM_SOCKET_B = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SWITCH_SOCKET_C = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		/// </summary>
		public const byte SWITCH_TO_OFF = 0;

		/// <summary>
		/// </summary>
		public const byte SWITCH_TO_ON = 1;

		/// <summary>
		/// </summary>
		public const byte SWITCHING_STATE_READY = 0;

		/// <summary>
		/// </summary>
		public const byte SWITCHING_STATE_BUSY = 1;


		/// <summary>
		///  This callback is called whenever the switching state changes
		///  from busy to ready, see <see cref="Tinkerforge.BrickletRemoteSwitch.GetSwitchingState"/>.
		/// </summary>
		public event SwitchingDoneEventHandler SwitchingDone;
		/// <summary>
		/// </summary>
		public delegate void SwitchingDoneEventHandler(BrickletRemoteSwitch sender);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletRemoteSwitch(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			this.apiVersion[0] = 2;
			this.apiVersion[1] = 0;
			this.apiVersion[2] = 1;
			callbackWrappers[CALLBACK_SWITCHING_DONE] = new CallbackWrapper(OnSwitchingDone);

			responseExpected[FUNCTION_SWITCH_SOCKET] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_SWITCHING_STATE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_REPEATS] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_REPEATS] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SWITCH_SOCKET_A] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_SWITCH_SOCKET_B] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_DIM_SOCKET_B] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_SWITCH_SOCKET_C] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_SWITCHING_DONE] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  This function is deprecated, use <see cref="Tinkerforge.BrickletRemoteSwitch.SwitchSocketA"/> instead.
		/// </summary>
		public void SwitchSocket(byte houseCode, byte receiverCode, byte switchTo)
		{
			byte[] request = CreateRequestPacket(11, FUNCTION_SWITCH_SOCKET);
			LEConverter.To((byte)houseCode, 8, request);
			LEConverter.To((byte)receiverCode, 9, request);
			LEConverter.To((byte)switchTo, 10, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the current switching state. If the current state is busy, the
		///  Bricklet is currently sending a code to switch a socket. It will not
		///  accept any calls of <see cref="Tinkerforge.BrickletRemoteSwitch.SwitchSocket"/> until the state changes to ready.
		///  
		///  How long the switching takes is dependent on the number of repeats, see
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.SetRepeats"/>.
		/// </summary>
		public byte GetSwitchingState()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_SWITCHING_STATE);

			byte[] response = SendRequest(request);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Sets the number of times the code is send when of the <see cref="Tinkerforge.BrickletRemoteSwitch.SwitchSocket"/>
		///  functions is called. The repeats basically correspond to the amount of time
		///  that a button of the remote is pressed.
		///  
		///  Some dimmers are controlled by the length of a button pressed,
		///  this can be simulated by increasing the repeats.
		///  
		///  The default value is 5.
		/// </summary>
		public void SetRepeats(byte repeats)
		{
			byte[] request = CreateRequestPacket(9, FUNCTION_SET_REPEATS);
			LEConverter.To((byte)repeats, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the number of repeats as set by <see cref="Tinkerforge.BrickletRemoteSwitch.SetRepeats"/>.
		/// </summary>
		public byte GetRepeats()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_REPEATS);

			byte[] response = SendRequest(request);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  To switch a type A socket you have to give the house code, receiver code and the
		///  state (on or off) you want to switch to.
		///  
		///  The house code and receiver code have a range of 0 to 31 (5bit).
		///  
		///  A detailed description on how you can figure out the house and receiver code
		///  can be found :ref:`here &lt;remote_switch_bricklet_type_a_house_and_receiver_code&gt;`.
		///  
		///  .. versionadded:: 2.0.1~(Plugin)
		/// </summary>
		public void SwitchSocketA(byte houseCode, byte receiverCode, byte switchTo)
		{
			byte[] request = CreateRequestPacket(11, FUNCTION_SWITCH_SOCKET_A);
			LEConverter.To((byte)houseCode, 8, request);
			LEConverter.To((byte)receiverCode, 9, request);
			LEConverter.To((byte)switchTo, 10, request);

			SendRequest(request);

		}

		/// <summary>
		///  To switch a type B socket you have to give the address, unit and the state
		///  (on or off) you want to switch to.
		///  
		///  The address has a range of 0 to 67108863 (26bit) and the unit has a range
		///  of 0 to 15 (4bit). To switch all devices with the same address use 255 for
		///  the unit.
		///  
		///  A detailed description on how you can teach a socket the address and unit can
		///  be found :ref:`here &lt;remote_switch_bricklet_type_b_address_and_unit&gt;`.
		///  
		///  .. versionadded:: 2.0.1~(Plugin)
		/// </summary>
		public void SwitchSocketB(long address, byte unit, byte switchTo)
		{
			byte[] request = CreateRequestPacket(14, FUNCTION_SWITCH_SOCKET_B);
			LEConverter.To((int)address, 8, request);
			LEConverter.To((byte)unit, 12, request);
			LEConverter.To((byte)switchTo, 13, request);

			SendRequest(request);

		}

		/// <summary>
		///  To control a type B dimmer you have to give the address, unit and the
		///  dim value you want to set the dimmer to.
		///  
		///  The address has a range of 0 to 67108863 (26bit), the unit and the dim value
		///  has a range of 0 to 15 (4bit).
		///  
		///  A detailed description on how you can teach a dimmer the address and unit can
		///  be found :ref:`here &lt;remote_switch_bricklet_type_b_address_and_unit&gt;`.
		///  
		///  .. versionadded:: 2.0.1~(Plugin)
		/// </summary>
		public void DimSocketB(long address, byte unit, byte dimValue)
		{
			byte[] request = CreateRequestPacket(14, FUNCTION_DIM_SOCKET_B);
			LEConverter.To((int)address, 8, request);
			LEConverter.To((byte)unit, 12, request);
			LEConverter.To((byte)dimValue, 13, request);

			SendRequest(request);

		}

		/// <summary>
		///  To switch a type C socket you have to give the system code, device code and the
		///  state (on or off) you want to switch to.
		///  
		///  The system code has a range of 'A' to 'P' (4bit) and the device code has a
		///  range of 1 to 16 (4bit).
		///  
		///  A detailed description on how you can figure out the system and device code
		///  can be found :ref:`here &lt;remote_switch_bricklet_type_c_system_and_device_code&gt;`.
		///  
		///  .. versionadded:: 2.0.1~(Plugin)
		/// </summary>
		public void SwitchSocketC(char systemCode, byte deviceCode, byte switchTo)
		{
			byte[] request = CreateRequestPacket(11, FUNCTION_SWITCH_SOCKET_C);
			LEConverter.To((char)systemCode, 8, request);
			LEConverter.To((byte)deviceCode, 9, request);
			LEConverter.To((byte)switchTo, 10, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnSwitchingDone(byte[] response)
		{
			var handler = SwitchingDone;
			if(handler != null)
			{
				handler(this);
			}
		}
	}
}